!******************************************************************************!
! Test case description/purpose: To show that the HTTPS port 443 has been added
! and is now working properly. If the plot is populated with a map and items
! on the U.S., then the HTTPS port is being used properly.
!
! Arguments: None
!
!
! @bug      NXM-2944 LayerMap.checkReachable does not handle default port for https
! @since    3.7.1
! @author:  Gregory Harris
!******************************************************************************!
startmacro
  switch INTERACTIVE interAct   GET DEF=TRUE  SDEF=TRUE  ! for normal interactive test(s)
  switch BASELINE    baseline   GET DEF=FALSE SDEF=TRUE  ! for defects or more obscure test case(s)
  switch ALTTESTENV  alttestenv GET DEF=FALSE SDEF=TRUE

  call setDatDir

  if interAct then
    if alttestenv then
      info "^reg.main.name: Skipping since the url this test references is not accessible &
            in the current alternate test environment"
    else
      set instructions "This tests if the HTTPS port 443 is being used. If you see a world plot and areas &
      drawn in the U.S. on the plot, and you do not see a warning for WARN: LayerWMS: Unable to access &
      'www.sciencebase.gov' using port -1: port out of range:-1 [PLOT] in the terminal, click pass to pass this test."

      pipe on
        panel/msgid=MAIN/setup/controls=gc
        gcontrol label macro "Test MACRO"
        gcontrol menu  main "Exit with Status =" "PASS,FAIL" TABLE={ItemColors={PASS="GREEN",FAIL="RED"}} /tleft
        gcontrol text  idtext "Instructions" instructions 24 12 /title

        plot {LT="WMS",URL="https://www.sciencebase.gov/catalogMaps/mapping/ows/4f4e4a2ee4b07f02db61574e",&
              DOWNLOADTHREADS=L:4,LAYERS="sb:footprint,sb:boundingBox,sb:NatlForest"}|^{datDir}.world.prm VIEW=LatLon
      pipe off
    endif

  endif
endmacro

!******************************************************************************!
! Main process message for this macro. Should be right after the ENDMACRO.
!******************************************************************************!
procedure processMessage m:msg
  if msg.name eqs "MAIN" then
    assert/text="^reg.main.name: User indicated tests" msg.data eqss "PASS"
    pipe stop
  else
    say "Unhandled message name: ^msg.name from fid: ^msg.fid data: ^msg.data"
  endif
return

!******************************************************************************!
! If an unexpected exception is caught, mark test as failed, unless it is expected
!******************************************************************************!
procedure processException m:emsg
  if expectedException REXISTS then
    assert/text="^reg.main.name: Expected ERROR starts with: ^{expectedException}" expectedException EQSS emsg.data.message
    remove expectedException
  else
    assert/text="^reg.main.name: Caught unexpected exception ^{emsg.data}" "FALSE" isTrue
    if "Trace" SUBS ENV.DEBUG then invoke ,, emsg.data.printStackTrace()
  endif
return

!******************************************************************************!
! Set the dat directory
!******************************************************************************!
procedure setDatDir
  invoke nxmMajor env.nmversion.subString(0,1)
  invoke major java.lang.Integer.valueOf(nxmMajor)
  if major GE 4 then
    invoke s:datDir           nxm.sys.test.DatLocator.getDatDirLocation()
    invoke s:datDirSlash      nxm.sys.test.DatLocator.getDatDirSlashLocation()
    invoke z:sysDatFull       nxm.sys.test.DatLocator.sysDatFull()
    invoke z:sysTestDatExists nxm.sys.test.DatLocator.sysTestDatExists()
  else
    set s:datDir           "nxm.sys.dat"
    set s:datDirSlash      "nxm/sys/dat"
    set z:sysDatFull       true
    set z:sysTestDatExists false
  endif
return
